%  Figure 12.1      Digital Control of Dynamic Systems, 3e 
%                   Franklin, Powell, Workman
%                   Addison-Wesley Publishing Company, 1998
% Matlab v4.2 or v5.0
% fig12_1.m generates the Fig 12.1 which shows the computation
% of a transfer function using a chirp input and the FFT.

clf
clear
f = [-.25 -1;1 0];
g = [1;0];
h = [0 1];
j = 0;
[phi,gam] = c2d(f,g,.5);
[b,a] = ss2tf(phi,gam,h,j,1);
w1 = 0:pi/128:pi;
w = w1(2:128);
[mag ph] = dbode(b,a,1,w); % use T=1 to get plot vs wT
u = chirp(.1,.75,256);
y = filter(b,a,u);
U = fft(u)/16;
Y = fft(y)/16;
Tf = Y(2:128)./U(2:128);
magch = abs(Tf);
phch1 = angle(Tf)*180/pi;
phch=[phch1(1:28) phch1(29:127)-360*ones(size(phch1(29:127)))];
subplot(2,2,1), plot(u),grid,title('chirp')
subplot(2,2,3),loglog(w,abs(U(2:128))), grid,title('chirp spectrum')
subplot(2,2,2), loglog(w,mag),
hold on, 
grid, 
loglog(w ,magch, 'x'),axis([.01 10 .01 10])
title('Transfer function')
hold off
subplot(2,2,4), semilogx(w,ph),grid,hold on, 
semilogx(w,phch,'x'), 
axis([.01 10  -300 0])
hold off
