%  Figure 12.3      Digital Control of Dynamic Systems, 3e 
%                   Franklin, Powell, Workman
%                   Addison-Wesley Publishing Company, 1998
% Matlab v4.2 or v5.0
% fig1203.m generates the Fig 12.3 which shows the computation
% of a transfer function using a chirp input and the FFT.
% using known parts

clf
clear
f = [-.25 -1 0 0;1 0 0 0; 0 1 0 0; 0 0 1 0];
g = [1;0;0;0];
h = [0 0 0 1];
j = 0;
[phi,gam] = c2d(f,g,.5);
[b,a] = ss2tf(phi,gam,h,j,1);
w1 = 0:pi/128:pi;
w = w1(2:128);
[mag ph] = dbode(b,a,1, w);
ph = ph - 360*ones(size(ph));
nk = [1 2 1];
dk = [1 -2 1];
[magk phk] = dbode(nk,dk,1, w);
u = chirp(.1,.75,256);
y = filter(b,a,u);
uf = filter(nk,1,u);
yf = filter(dk,1,y);
U = fft(u)/16;
Y = fft(y)/16;
Uf = fft(uf)/16;
Yf = fft(yf)/16;
Tf = Y(2:128)./U(2:128);
Tff = Yf(2:128)./Uf(2:128);
magch = abs(Tf);
phch1 = angle(Tf)*180/pi;
% phch = unwrap(phch1); 
phch1 = phch1 - 360*ones(size(phch1));
magf = abs(Tff);
phf = angle(Tff)*180/pi;
magchf = magf'.*magk;
phchf1 = phf' + phk;
phchf=[phchf1(1:28)'  phchf1(29:127)'-360*ones(size(phchf1(29:127)'))]';
% phchf =  unwrap(phchf1);
subplot(2,2,1), loglog(w,mag),hold on, loglog(w,magch,'x'),grid, axis([.01 10 .001 1000]),title('Raw estimate')
hold off
subplot(2,2,3),semilogx(w,ph),hold on,semilogx(w,phch1,'x'), grid, axis([.01 10 -500 -100])
hold off
subplot(2,2,2),loglog(w,mag),hold on, loglog(w,magchf,'x'), axis([.01 10 .001 1000]), grid
title('Estimate with filtering')
hold off
subplot(2,2,4),semilogx(w,ph),hold on, semilogx(w,phchf,'x') ,axis([.01 10 -500 -100]),grid
hold off
