%  Figure 12.5      Digital Control of Dynamic Systems, 3e 
%                   Franklin, Powell, Workman
%                   Addison-Wesley Publishing Company, 1998
% Matlab v4.2 or v5.0
% function fig12_5  generates the Fig 12.5 which shows the computation
% of a transfer function using a random input and spectral
% analysis with output noise/signal ratio a.

clf
clear
a=.2;
f = [-.25 -1 ;1 0 ];
g = [1;0];
h = [ 0 1];
j = 0;
[phi,gam] = c2d(f,g,.5);
w1 = 0:pi/64:pi;
w = w1(2:64);
[mag ph] = dbode(phi,gam,h,j,1,1,w);
% ph = ph - 360*ones(size(ph));
rand('seed',0);
u = rand(256,1);
u = u- ones(size(u))*mean(u);
y = dlsim(phi,gam,h,j,u);
v = rand(256,1);
v = v - ones(size(v))*mean(v);
yn = y + a*v;
ru1 = xcorr(u);
ru = ru1(128:383);
wh = hamming(256);
rubar = ru.*wh;
ryu1 = xcorr(y,u);
ryu = ryu1(128:383);
ryubar = ryu.*wh;
ryun1 = xcorr(yn,u);
ryun = ryun1(128:383);
ryunbar = ryun.*wh;
Syu = fft(ryubar);
Syun = fft(ryunbar);
Suu = fft(rubar);
Tf = Syu./Suu;
Tfn = Syun./Suu;
magr = abs(Tf(3:2:128));
phr1 = -angle(Tf(3:2:128));
phr = unwrap(phr1);  phr =  phr*180/pi;
magn = abs(Tfn(3:2:128));
phn1 = -angle(Tfn(3:2:128)); phn=unwrap(phn1);
phn = phn*180/pi;  
subplot(2,2,1), loglog(w,mag),axis([.01 10 .001 10])
hold on, loglog(w,magr,'x'),grid,title('smoothed estimate')
hold off
subplot(2,2,3),semilogx(w,ph),hold on,semilogx(w,phr,'x'), grid
axis([.01 10 -300 0]);hold off
subplot(2,2,2), loglog(w,mag),axis([.01 10 .001 10])
hold on, loglog(w,magn,'x'),grid,title('estimate with noise')
hold off
subplot(2,2,4),semilogx(w,ph),hold on,semilogx(w,phn,'x'), grid
axis([.01 10 -300 0])
hold off
